/* Cory McWilliams   *
 * mcwilc@rpi.edu    *
 * December 12, 2003 */

#ifndef CABINH
#define CABINH

#include "object.h"
#include <GL/glut.h>
#include "texture.h"

const int gCabinLogSlices = 8;
const int gCabinLogStacks = 3;
const int gCabinSmoke = 32;

class Cabin : public Object {
	GLUquadric *gluq;
	Texture mCedar;
	Texture mStone;
	Texture mFire[4];
	Texture mFirewood;
	bool mInit;
	int mFireCell;
	float mSmoke[gCabinSmoke][4];
	void log(float radius, float offset, float length);
	void rectangularPrism(vertex c1, vertex c2);
public:
	Cabin() : mInit(false), mFireCell(0) {
		gluq = gluNewQuadric();
		for (int i = 0; i < gCabinSmoke; i++)
			mSmoke[i][3] = 0.0f;
	}
	~Cabin() { gluDeleteQuadric(gluq); }
	void display();
	void update(float t);
};

#endif
