#!/usr/bin/perl

use Math::Trig;

$steps = 5;

print "\tglBegin(GL_QUAD_STRIP);\n";

for $i (0 .. $steps - 1) {
	$x = 1.5 + cos(pi * ($i / 4.0) - pi / 2) * 0.25;
	$y = 0.10 + (sin(pi * ($i / 4.0) - pi / 2) + 1.0) * 0.25;
	$nx = cos(pi * ($i / 4.0) - pi / 2);
	$ny = -sin(pi * ($i / 4.0) - pi / 2);
	printf "\tglNormal3f(%.4f, %.4f, %.4f);\n", $nx, $ny, 0.0;
	printf "\tglTexCoord2f(%.4f, %.4f);\n", 0.0, $i / ($steps - 1);
	printf "\tglVertex3f(%.4f, %.4f, %.4f);\n", $x, $y, -0.5;
	printf "\tglTexCoord2f(%.4f, %.4f);\n", 1.0, $i / ($steps - 1);
	printf "\tglVertex3f(%.4f, %.4f, %.4f);\n", $x, $y, 0.5;
}

for ($i = $steps - 1; $i >= 0; $i--) {
	$x = 1.5 + cos(pi * ($i / 4.0) - pi / 2) * 0.35;
	$y = 0.0 + (sin(pi * ($i / 4.0) - pi / 2) + 1.0) * 0.35;
	$nx = cos(pi * ($i / 4.0) - pi / 2);
	$ny = sin(pi * ($i / 4.0) - pi / 2);
	printf "\tglNormal3f(%.4f, %.4f, %.4f);\n", $nx, $ny, 0.0;
	printf "\tglTexCoord2f(%.4f, %.4f);\n", 0.0, $i / ($steps - 1);
	printf "\tglVertex3f(%.4f, %.4f, %.4f);\n", $x, $y, -0.5;
	printf "\tglTexCoord2f(%.4f, %.4f);\n", 1.0, $i / ($steps - 1);
	printf "\tglVertex3f(%.4f, %.4f, %.4f);\n", $x, $y, 0.5;
}

print "\tglEnd();\n";
print "\tglNormal3f(-1.0f, 0.0f, 0.0f);\n";
print "\tglBegin(GL_QUAD_STRIP);\n";

for $i (0 .. $steps - 1) {
	$x1 = 1.5 + cos(pi * ($i / 4.0) - pi / 2) * 0.25;
	$y1 = 0.10 + (sin(pi * ($i / 4.0) - pi / 2) + 1.0) * 0.25;
	$x2 = 1.5 + cos(pi * ($i / 4.0) - pi / 2) * 0.35;
	$y2 = 0.0 + (sin(pi * ($i / 4.0) - pi / 2) + 1.0) * 0.35;
	printf "\tglTexCoord2f(%.4f, %.4f);\n", 0.0, $i / ($steps - 1);
	printf "\tglVertex3f(%.4f, %.4f, %.4f);\n", $x2, $y2, -0.5;
	printf "\tglTexCoord2f(%.4f, %.4f);\n", 0.2, $i / ($steps - 1);
	printf "\tglVertex3f(%.4f, %.4f, %.4f);\n", $x1, $y1, -0.5;
}

print "\tglEnd();\n";
print "\tglNormal3f(1.0f, 0.0f, 0.0f);\n";
print "\tglBegin(GL_QUAD_STRIP);\n";

for $i (0 .. $steps - 1) {
	$x1 = 1.5 + cos(pi * ($i / 4.0) - pi / 2) * 0.25;
	$y1 = 0.10 + (sin(pi * ($i / 4.0) - pi / 2) + 1.0) * 0.25;
	$x2 = 1.5 + cos(pi * ($i / 4.0) - pi / 2) * 0.35;
	$y2 = 0.0 + (sin(pi * ($i / 4.0) - pi / 2) + 1.0) * 0.35;
	printf "\tglTexCoord2f(%.4f, %.4f);\n", 0.0, $i / ($steps - 1);
	printf "\tglVertex3f(%.4f, %.4f, %.4f);\n", $x1, $y1, 0.5;
	printf "\tglTexCoord2f(%.4f, %.4f);\n", 0.2, $i / ($steps - 1);
	printf "\tglVertex3f(%.4f, %.4f, %.4f);\n", $x2, $y2, 0.5;
}

print "\tglEnd();\n";
