/* Cory McWilliams   *
 * mcwilc@rpi.edu    *
 * December 12, 2003 */

#include <iostream>
using std::cerr;

template<class T>
Matrix<T>::Matrix(unsigned int newWidth, unsigned int newHeight)
: matrixWidth(newWidth), matrixHeight(newHeight)
{
	unsigned int size = newWidth * newHeight;
	
	data.resize(size);
}

template<class T>
T &Matrix<T>::at(unsigned int x, unsigned int y)
{
	// DEBUG
	if (x < 0 || y < 0 || x >= matrixWidth || y >= matrixHeight)
		std::cerr << "Referenced matrix out of bounds, you shmuck! (" << x << " / " << matrixWidth << ", " << y << " / " << matrixHeight << ")" << std::endl;

	return data[y * matrixWidth + x];
}

template<class T>
const T &Matrix<T>::at(unsigned int x, unsigned int y) const
{
	// DEBUG
	if (x < 0 || y < 0 || x >= matrixWidth || y >= matrixHeight)
		cerr << "Referenced matrix out of bounds, you shmuck! (" << x << ", " << y << ")" << endl;
	return data[y * matrixWidth + x];
}

template<class T>
unsigned int Matrix<T>::width() const
{
	return matrixWidth;
}

template<class T>
unsigned int Matrix<T>::height() const
{
	return matrixHeight;
}

template<class T>
void Matrix<T>::resize(unsigned int newWidth, unsigned int newHeight)
{
	unsigned int size = newWidth * newHeight;
	data.resize(size);
	matrixWidth = newWidth;
	matrixHeight = newHeight;
}
