/* Cory McWilliams   *
 * mcwilc@rpi.edu    *
 * December 12, 2003 */

#include "movingobject.h"
#include <math.h>

MovingObject::MovingObject() {
	mVelocity.x = mVelocity.y = mVelocity.z = 0.0f;
}

void MovingObject::accelerate(float magnitude, vertex angles) {
	float theta = angles.y * 3.14159f / 180.0f; 
	float phi = angles.x * 3.14159f / 180.0f; 
	vertex newVelocity(magnitude * cos(phi) * sin(theta),
		-magnitude * sin(phi),
		magnitude * cos(phi) * cos(theta));
	mVelocity += -1.0f * newVelocity;
}

void MovingObject::advance(float t) {
	position() += mVelocity * t;
}
