/* Cory McWilliams   *
 * mcwilc@rpi.edu    *
 * December 12, 2003 */

#include "object.h"

#include <math.h>

#ifndef M_PI
#define M_PI 3.1415926535358979323846
#endif

Object::Object() {
	mPosition.x = mPosition.y = mPosition.z = 0.0f;
	mRotation.x = mRotation.y = mRotation.z = 0.0f;
}

void Object::translate(vertex tr) {
	double theta = mRotation.y * M_PI / 180.0;
	float sint = sin(theta);
	float cost = cos(theta);
	mPosition.y += tr.y;
	mPosition.x += tr.z * sint + tr.x * cost;
	mPosition.z += tr.z * cost - tr.x * sint;
}

void Object::rotate(vertex rot) {
	mRotation += rot;
}
