/* Cory McWilliams   *
 * mcwilc@rpi.edu    *
 * December 12, 2003 */

#ifndef SNOWFALLH
#define SNOWFALLH

#include <vector>
#include "vertex.h"

class Snowfall {
	struct Box {
		vertex p1;
		vertex p2;
		bool inside;
	};
	struct Flake {
		vertex p;
		vertex r;
		float rot;
		bool alive;
	};
	vertex mSpawn[2];
	std::vector<Box> mConstraints;
	std::vector<Flake> mParticles;
public:
	Snowfall(int particles = 64);
	void update(vertex motion);
	void spawn(vertex p1, vertex p2);
	void limit(vertex p1, vertex p2, bool inside);
	void display();
};

#endif
