/* Cory McWilliams   *
 * mcwilc@rpi.edu    *
 * December 12, 2003 */

#include "texture.h"
#include <GL/gl.h>
#include <vector>
#include <fstream>
#include <iostream>

Texture::Texture(const char *filename)
: mTexture(0) {
	if (filename) load(filename);
}

bool Texture::load(const char *filename) {
	std::ifstream file(filename, std::ios::binary|std::ios::in);
	std::vector<char> data;
	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	data.resize(256*256*3);
	if (file.read(&*data.begin(), 256*256*3)) {
		glGenTextures(1, &mTexture);
		glBindTexture(GL_TEXTURE_2D, mTexture);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 256, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, &*data.begin());
		return true;
	} else {
		std::cerr << "Error loading " << filename << "\n";
		return false;
	}
}

Texture::~Texture() {
	if (mTexture) glDeleteTextures(1, &mTexture);
}

void Texture::apply() {
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, mTexture);
}

void Texture::none() {
	glBindTexture(GL_TEXTURE_2D, 0);
}
