/* Cory McWilliams   *
 * mcwilc@rpi.edu    *
 * December 12, 2003 */

#include "treeline.h"
#include <GL/gl.h>
#include "vertex.h"

void TreeLine::display(Terrain &terrain) {
	int w = terrain.width() - 3;
	int h = terrain.height() - 3;
	vertex scale = terrain.scale();
	float height = 6.0f;

	glBegin(GL_QUADS);
	for (int i = 0; i < w; i++) {
		glNormal3f(1.0f, 0.0f, 0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(scale.x * i / w, terrain.at(i + 1, 1).height * scale.y, 0.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(scale.x * (i + 1) / w, terrain.at(i + 2, 1).height * scale.y, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(scale.x * (i + 1) / w, terrain.at(i + 2, 1).height * scale.y + height, 0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(scale.x * i / w, terrain.at(i + 1, 1).height * scale.y+ height, 0.0f);

		glNormal3f(1.0f, 0.0f, -0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(scale.x * i / w, terrain.at(i + 1, h + 1).height * scale.y, scale.z);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(scale.x * (i + 1) / w, terrain.at(i + 2, h + 1).height * scale.y, scale.z);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(scale.x * (i + 1) / w, terrain.at(i + 2, h + 1).height * scale.y + height, scale.z);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(scale.x * i / w, terrain.at(i + 1, h + 1).height * scale.y + height, scale.z);
	}
	for (int i = 0; i < h; i++) {
		glNormal3f(0.0f, 0.0f, 1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(0.0f, terrain.at(1, i + 1).height * scale.y, scale.x * i / w);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(0.0f, terrain.at(1, i + 2).height * scale.y, scale.x * (i + 1) / w);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(0.0f, terrain.at(1, i + 2).height * scale.y + height, scale.x * (i + 1) / w);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(0.0f, terrain.at(1, i + 1).height * scale.y + height, scale.x * i / w);

		glNormal3f(-0.0f, 0.0f, 1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(scale.x, terrain.at(w + 1, i + 1).height * scale.y, scale.x * i / w);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(scale.x, terrain.at(w + 1, i + 2).height * scale.y, scale.x * (i + 1) / w);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(scale.x, terrain.at(w + 1, i + 2).height * scale.y + height, scale.x * (i + 1) / w);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(scale.x, terrain.at(w + 1, i + 1).height * scale.y + height, scale.x * i / w);
	}
	glEnd();
}
