/* Cory McWilliams   *
 * mcwilc@rpi.edu    *
 * December 12, 2003 */

#ifndef VERTEXH
#define VERTEXH

struct vertex2 {
	float x;
	float y;
};

struct vertex3 {
	vertex3() {}
	vertex3(float nx, float ny, float nz) : x(nx), y(ny), z(nz) {}
	float x;
	float y;
	float z;
};

typedef vertex3 vertex;

// Just enough vertex/vector operations are implemented to do what we need.
float abs(const vertex &a);
vertex normalize(const vertex &a);
vertex crossProduct(const vertex &a, const vertex &b);
float dotProduct(const vertex &a, const vertex &b);
vertex3 operator+(vertex3 const &a, vertex3 const &b);
vertex3 operator-(vertex3 const &a, vertex3 const &b);
vertex3 operator*(float a, const vertex &v);
vertex3 operator*(const vertex &v, float a);
vertex3 &operator+=(vertex3 &a, vertex3 const &b);
vertex3 operator/(vertex3 const &a, float b);
vertex3 &operator/=(vertex3 &a, float b);
vertex3 Vertex3(float x, float y, float z);

float relativeComponent(const vertex &r, const vertex &x, float absx);
float relativeVelocity(const vertex &PA, const vertex &PB, const vertex &VA, const vertex &VB);
bool inside(vertex p, vertex e1, vertex e2);

#endif
